import json
import requests
from resources.lib.utils.url import Url


def get_highest_quality(formats):
    return max(formats, key=lambda x: x.get('bitrate'))


def get_yt_video_url(url):
    url_data = Url.urlparse(url)
    query = Url.parse_qs(url_data.query)
    video_id = query["v"][0]
    r = requests.get(url='https://www.youtube.com/get_video_info?video_id=%s&' % video_id)
    stream_data = Url.parse_qs(r.content.decode('ascii'))
    player_response = json.loads(stream_data["player_response"][0])
    formats = player_response["streamingData"]["formats"]
    highest_quality = get_highest_quality([format for format in formats if format.get('audioQuality')])

    return highest_quality['url']
